VERSION 5.00
Begin VB.Form ConvertBasesForm 
   Caption         =   "Convert Bases"
   ClientHeight    =   3030
   ClientLeft      =   1890
   ClientTop       =   1545
   ClientWidth     =   3765
   Icon            =   "ConvertBases.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   202
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   251
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox OutputBaseText 
      Height          =   375
      Left            =   2880
      TabIndex        =   1
      Text            =   "36"
      Top             =   0
      Width           =   855
   End
   Begin VB.TextBox InputBaseText 
      Height          =   375
      Left            =   960
      TabIndex        =   0
      Text            =   "10"
      Top             =   0
      Width           =   855
   End
   Begin VB.TextBox OutputText 
      BackColor       =   &H80000013&
      Height          =   1200
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   1800
      Width           =   3735
   End
   Begin VB.TextBox InputText 
      Height          =   1200
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   480
      Width           =   3735
   End
   Begin VB.Label Label2 
      Caption         =   "Output Base"
      Height          =   255
      Left            =   1920
      TabIndex        =   5
      Top             =   60
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Input Base"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   60
      Width           =   975
   End
End
Attribute VB_Name = "ConvertBasesForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function Divide(DivIn2 As String, DivBy2 As String) As String
Dim DivideWork As String
Dim Carry As String
Dim ExtraBlock As String
Dim DivIn As String
Dim DivBy As String
DivIn = DivIn2
DivBy = DivBy2
Carry = ""
Do
    Carry = Carry + Left$(DivIn, 1)
    DivIn = Right$(DivIn, Len(DivIn) - 1)
    ExtraBlock = Carry \ DivBy
    If ExtraBlock = 0 Then
        DivideWork = DivideWork + "0"
    Else
        DivideWork = DivideWork + ExtraBlock
        Carry = Carry Mod DivBy
    End If
Loop Until DivIn = ""
Do Until Left$(DivideWork, 1) <> "0"
    DivideWork = Right$(DivideWork, Len(DivideWork) - 1)
Loop
If DivideWork = "" Then DivideWork = 0
Divide = DivideWork
End Function

Private Function Multiply(Mul1 As String, Mul2 As String) As String
Dim MulFinal As String
Dim MulThru As Byte
Dim Carry As Byte
Dim Adding As String
Dim i As Integer
Dim p As Integer
For i = 1 To Len(Mul1)
    Adding = ""
    For p = 1 To Len(Mul2)
        MulThru = Mid$(Mul1, Len(Mul1) - i + 1, 1) * Mid$(Mul2, Len(Mul2) - p + 1, 1) + Carry
        Adding = Right$(MulThru, 1) + Trim$(Adding)
        If Len(Trim$(MulThru)) = 2 Then
            Carry = Left$(MulThru, 1)
        Else
            Carry = 0
        End If
    Next p
    Adding = Trim$(Carry) + Adding + String(i - 1, "0")
    MulFinal = Add(MulFinal, Adding)
    Carry = 0
Next i
Do While Left$(MulFinal, 1) = "0"
    MulFinal = Right$(MulFinal, Len(MulFinal) - 1)
Loop
If MulFinal = "" Then MulFinal = 0
Multiply = MulFinal
End Function

Private Function Add(AddA1 As String, AddA2 As String) As String
Dim Add1 As String
Dim Add2 As String
Dim AddFinal As String
Dim Carry As Byte
Dim AddThru As Byte
Dim Length As String
Dim i As Long
Add1 = AddA1
Add2 = AddA2
If Len(Add1) < Len(Add2) Then
    Length = Len(Add2)
    For i = Len(Add1) To Length - 1
        Add1 = "0" + Add1
    Next i
ElseIf Len(Add1) > Len(Add2) Then
    Length = Len(Add1)
    For i = Len(Add2) To Length - 1
        Add2 = "0" + Add2
    Next i
Else
    Length = Len(Add1)
End If
For i = Length To 1 Step -1
    AddThru = Carry
    Carry = 0
    AddThru = Val(AddThru) + Mid$(Add1, i, 1)
    AddThru = Val(AddThru) + Mid$(Add2, i, 1)
    AddFinal = Right$(AddThru, 1) + AddFinal
    If AddThru > 9 Then Carry = 1
Next i
If Carry = 1 Then AddFinal = "1" + AddFinal
Add = AddFinal
End Function

Private Function Subtract(SubA1 As String, SubA2 As String) As String
Dim Sub1 As String
Dim Sub2 As String
Dim SubFinal As String
Dim SubThru As Byte
Dim Length As String
Dim i As Long
Dim Adding As String
Sub1 = SubA1
Sub2 = SubA2
If Len(Sub1) < Len(Sub2) Then
    Length = Len(Sub2)
    For i = Len(Sub1) To Length - 1
        Sub1 = "0" + Sub1
    Next i
ElseIf Len(Sub1) > Len(Sub2) Then
    Length = Len(Sub1)
    For i = Len(Sub2) To Length - 1
        Sub2 = "0" + Sub2
    Next i
Else
    Length = Len(Sub1)
End If
For i = Length To 1 Step -1
    Adding = "0"
    If Mid$(Sub1, i, 1) = "A" Then
        Sub1 = Left$(Sub1, i - 1) + "9" + Right$(Sub1, Len(Sub1) - i)
        If Trim$(Mid$(Sub1, i - 1, 1) - 1) = -1 Then
            Sub1 = Left$(Sub1, i - 2) + "A" + Right$(Sub1, Len(Sub1) - i + 1)
        Else
            Sub1 = Left$(Sub1, i - 2) + Trim$(Mid$(Sub1, i - 1, 1) - 1) + Right$(Sub1, Len(Sub1) - i + 1)
        End If
    End If
    If Mid$(Sub1, i, 1) < Mid$(Sub2, i, 1) And Adding = "0" Then
        If Trim$(Mid$(Sub1, i - 1, 1) - 1) = -1 Then
            Sub1 = Left$(Sub1, i - 2) + "A" + Right$(Sub1, Len(Sub1) - i + 1)
        Else
            Sub1 = Left$(Sub1, i - 2) + Trim$(Mid$(Sub1, i - 1, 1) - 1) + Right$(Sub1, Len(Sub1) - i + 1)
        End If
        Adding = "10"
    End If
    SubThru = Val(Mid$(Sub1, i, 1)) - Val(Mid$(Sub2, i, 1)) + Val(Adding)
    SubFinal = Trim$(SubThru) + SubFinal
Next i
Do While Left$(SubFinal, 1) = "0" And Len(SubFinal) <> 1
    SubFinal = Right$(SubFinal, Len(SubFinal) - 1)
Loop
Subtract = SubFinal
End Function

Private Sub ConvertBases()
'Get the input and output bases
Dim InputBase As Byte, OutputBase As Byte
InputBase = Val(InputBaseText.Text) And 255
OutputBase = Val(OutputBaseText.Text) And 255

'Check for invalid input/output base
If InputBase < 2 Or InputBase > 36 Or OutputBase < 2 Or OutputBase > 36 Then
    OutputText.Text = "Input and output bases must be between 2 and 36"
    Exit Sub
End If

'Check for no input
If InputText = "" Then
    OutputText.Text = "No input found"
    Exit Sub
End If

'Convert the input number into a base 10 integer, also confirming each character's validity
Dim i As Integer
Dim InputInBase10 As String
Dim Multiplier As String
Dim InputBaseStr As String
InputBaseStr = Trim(Str(InputBase))
Multiplier = "1"
For i = Len(InputText.Text) - 1 To 0 Step -1 'Go backwards to start at the least significant digit
    'Determine the value of the current character by assuming 0-9 and A-Z are the 2 ranges
    Dim InputCharacter As Integer
    InputCharacter = UCase(Asc(Mid(InputText.Text, i + 1, 1)))
    If InputCharacter >= Asc("0") And InputCharacter <= Asc("9") Then
        InputCharacter = InputCharacter - Asc("0")
    ElseIf InputCharacter >= Asc("A") And InputCharacter <= Asc("Z") Then
        InputCharacter = InputCharacter - Asc("A") + 10
    Else 'If character is not recognized, error out
        OutputText.Text = "Invalid character detected. Must be between 0-9 and A-Z"
        Exit Sub
    End If
    
    'Make sure the character is within the valid range
    If InputCharacter > InputBase Then
        OutputText.Text = "Invalid character detected. Must be below InputBase."
        Exit Sub
    End If
    
    'Add the character to the base 10 integer
    If InputBase <> 10 Then 'Bypass if we are already in base 10
        InputInBase10 = Add(InputInBase10, Multiply(Multiplier, Trim(Str(InputCharacter))))
        Multiplier = Multiply(Multiplier, InputBaseStr)
    End If
Next i

'If inputting in base 10, conversion is done implicitly
If InputBase = 10 Then
    InputInBase10 = InputText.Text
End If

'Short curcuit outputting in Base10
If OutputBase = 10 Then
    OutputText.Text = InputInBase10
    Exit Sub
End If

'Convert from Base10 to BaseOutput
Dim OutputNum As String, BaseOn As String, Modulus As String
BaseOn = Trim(Str(OutputBase))
Do
    Modulus = Subtract(InputInBase10, Multiply(Divide(InputInBase10, BaseOn), BaseOn))  '(InputInBase10%BaseOn) to get the next digit
    
    'Convert the digit and add it to the output string
    Select Case Val(Modulus)
        Case 0 To 9: OutputNum = Modulus + OutputNum
        Case 10 To 255: OutputNum = Chr$(Modulus + 55) + OutputNum
    End Select
    
    InputInBase10 = Divide(InputInBase10, BaseOn) 'Move on to the next digit
Loop Until InputInBase10 = "0"

OutputText.Text = OutputNum
End Sub

Private Sub Form_Load()
InputText = "41313458195755913" 'BASECONVERT in 10 to 36
ConvertBases
End Sub

Private Sub Form_Resize()
'Resize input and output boxes to fill in the form space
InputText.Width = ConvertBasesForm.ScaleWidth
InputText.Height = (ConvertBasesForm.ScaleHeight - 44) / 2

OutputText.Width = InputText.Width
OutputText.Height = InputText.Height
OutputText.Top = 40 + InputText.Height
End Sub

Private Sub InputBaseText_Change()
ConvertBases
End Sub

Private Sub InputText_Change()
ConvertBases
End Sub

Private Sub OutputBaseText_Change()
ConvertBases
End Sub
